console.log("hello world background todo something~");

import {
    backTwitterPinLoginToken,
    backTwitterPinLoginCode,
} from "../logic/twitter.js";

import { setChromeStorage, getChromeCookie, LANDING_PAGE, setChromeCookie, LANDING_PAGE_MIND } from "../uilts/chromeExtension";
import { guid } from '../uilts/help.js'

chrome.runtime.onInstalled.addListener(onInstalledMethod);

chrome.runtime.onMessage.addListener(onMessageMethod);

function onInstalledMethod() {
    getChromeCookie(LANDING_PAGE, (res_arr) => {
        if (res_arr && res_arr.length) {
            let { postNickName, srcContentId } = res_arr[res_arr.length - 1];
            if (postNickName && srcContentId) {
                let url = `https://twitter.com/${postNickName}/status/${srcContentId}`
                chrome.tabs.create({
                    url
                });
            }
        } else {
            backTwitterPinLoginToken();
        }
    })
    getChromeCookie(LANDING_PAGE_MIND, (res_arr) => {
        // 没有cookie
        if (res_arr && res_arr.length) {
            setChromeStorage({ mid: JSON.stringify(res_arr[0]) })
        } else {
            let _params = {
                mid: guid()
            }
            setChromeCookie(LANDING_PAGE, { 'mid': _params.mid })
            setChromeStorage({ mid: JSON.stringify(_params) })
        }
    })
}

function onMessageMethod(req, sender, sendResponse) {
    if (req) {
        switch (req.method) {
            case "POPUP_LOGIN":
                popupLogin(sendResponse);
                break;
            case "POPUP_PUBLISH_TWITTER_RED_PACK":
                setChromeStorage({
                    popupShowPublishDialog: JSON.stringify({
                        show: true,
                        srcContent: req.data.srcContent,
                        postId: req.data.postId
                    }),
                });
                chrome.tabs.create({
                    url: "https://twitter.com",
                });
                break;
        }
    }
    return true; // remove this line to make the call sync!
}

//
function popupLogin() {
    backTwitterPinLoginToken();
}

// 消息通讯
chrome.runtime.onConnect.addListener(function (port) {
    port.onMessage.addListener(function (res) {
        switch (res.state) {
            case "CONTENT_SEND_CODE":
                port.postMessage({
                    state: "BACK_TWITTER_LOGIN_SUCCESS",
                });
                backTwitterPinLoginCode(res.code);
                break;
            case "CONTENT_TWITTER_LOGIN":
                backTwitterPinLoginToken();
                break;
        }
    });
});
